/*utf8解析行 Don't remove or modify this first line!*/
#ifndef INIFILEMANAGER_H
#define INIFILEMANAGER_H


#include "WNCLoopList.h"
//#include "EBaseFunctions.h"
#include <string>
#include <sstream>
#include <ctype.h> 
using namespace std;
class IniSectionInfo;
class IniFileManager;



typedef unsigned char u_char;

#ifndef INI_CRLF
#define INI_CRLF "\r\n"
#endif

/*
 * This array is designed for mapping upper and lower case letter
 * together for a case independent comparison.  The mappings are
 * based upon ascii character sequences.
 */

int strcasecmp(const char *s1, const char* s2);

class NoCase
{
public:
static bool compare(const string& x, const string& y);
};


class IniKeyInfo
{
public:
    IniKeyInfo();
    inline void SetSection(IniSectionInfo* pSection) { m_pSection = pSection; }
    inline IniSectionInfo* GetSection() const { return m_pSection; }
    inline string& KeyName() { return m_strKeyName; }
    inline string& KeyValue() { return m_strKeyValue; }
	inline string KeyNameEx() { return m_strKeyTrimLeft + m_strKeyName + m_strKeyTrimRight; }
	inline string KeyValueEx() { return m_strValueTrimLeft + m_strKeyValue + m_strValueTrimRight; }
    inline void SetLong(long lKeyValue) {ostringstream tempstream;tempstream << lKeyValue;m_strKeyValue=tempstream.str();/*ww m_strKeyValue.Format(("%d"), lKeyValue);*/ }
    inline void SetULong(unsigned long ulKeyValue) { ostringstream tempstream;tempstream << ulKeyValue;m_strKeyValue=tempstream.str();/*m_strKeyValue.Format(("%u"), ulKeyValue);*/}
    inline void SetHex(long lKeyValue) { ostringstream tempstream;tempstream << hex  << lKeyValue;m_strKeyValue=tempstream.str();/*m_strKeyValue.Format(("%X"), lKeyValue);*/ }
    inline void SetUHex(unsigned long ulKeyValue) {ostringstream tempstream;tempstream << hex  << ulKeyValue;m_strKeyValue=tempstream.str();/* m_strKeyValue.Format(("%X"), ulKeyValue); */}
	inline void SetDouble(double dblKeyValue) {ostringstream tempstream;tempstream << dblKeyValue;m_strKeyValue=tempstream.str();}
    inline void SetString(const char* lpKeyValue) {ostringstream tempstream;tempstream <<  lpKeyValue;m_strKeyValue=tempstream.str(); /*m_strKeyValue = lpKeyValue; */}
	void SetKeyName(const char* lpKeyName, bool bDoTrim = true);
	void SetKeyValue(const char* lpKeyValue, bool bDoTrim = true);
	void SetMultiLineString(const char* lpKeyValue);
    long ToLong(long lDefault = 0);
    unsigned long ToULong(unsigned long ulDefault = 0);
    long ToHex(long lDefault = 0);
    unsigned long ToUHex(unsigned long ulDefault = 0);
	double ToDouble(double dblDefault = 0.0);
    string ToString(const char* lpDefault = (""));
	string ToMultiLineString(const char* lpDefault = (""));
    inline string GetText(); //{ return m_strKeyName == ("")?m_strKeyValue:(m_strKeyName + ('=') + m_strKeyValue); }
    inline string GetTextEx(); //{ return (m_strKeyName == (""))?((m_strKeyValue == (""))?(""):(("\r\n") + m_strKeyValue)):(("\r\n") + m_strKeyName + ('=') + m_strKeyValue); }
protected:
	void TrimAndGetTrimValue(string& strSrc, string& strTrimLeft, string& strTrimRight);
	const char* SplitStrP();
	string& SplitStrR();
protected:
    string m_strKeyName;
	string m_strKeyValue;
	string m_strKeyTrimLeft;
	string m_strKeyTrimRight;
	string m_strValueTrimLeft;
	string m_strValueTrimRight;
	//unsigned int m_uKeyNameLeftSpaceCount;
	//unsigned int m_uKeyNameRightSpaceCount;
	//unsigned int m_uKeyValueLeftSpaceCount;
	//unsigned int m_uKeyValueRightSpaceCount;
    IniSectionInfo* m_pSection;
};

typedef IniKeyInfo* PIniKeyInfo;


class IniSectionInfo : public WNCLoopList<IniKeyInfo>
{
public:
    IniSectionInfo();
    inline string& SectionName() { return m_strSectionName; }
    inline void SetManager(IniFileManager* pManager) { m_pManager = pManager; }
    inline IniFileManager* GetManager() { return m_pManager; }
    inline PIniKeyInfo AddKey(const char* lpKeyName) { return GetKey(lpKeyName, true); }
    PIniKeyInfo AddKey(const char* lpKeyName, const char* lpKeyValue, bool bReplace = true);
    PIniKeyInfo AddKeyEx(const char* lpKeyName);
    PIniKeyInfo AddKeyEx(const char* lpKeyName, const char* lpKeyValue);
    PIniKeyInfo ParseData(const char* lpData, bool bReplace = true);
    PIniKeyInfo ParseDataEx(const char* lpData);
    PIniKeyInfo GetKey(const char* lpKeyName, bool bAdd = false);
    long ToLong(const char* lpKeyName, long lDefault = 0);
    unsigned long ToULong(const char* lpKeyName, unsigned long ulDefault = 0);
    long ToHex(const char* lpKeyName, long lDefault = 0);
    unsigned long ToUHex(const char* lpKeyName, unsigned long ulDefault = 0);
    double ToDouble(const char* lpKeyName, double dblDefault = 0.0);
	string ToString(const char* lpKeyName, const char* lpDefault = (""));
	string ToMultiLineString(const char* lpKeyName, const char* lpDefault = (""));
    inline void SetLong(const char* lpKeyName, long lKeyValue) { AddKey(lpKeyName)->SetLong(lKeyValue); }
    inline void SetULong(const char* lpKeyName, unsigned long ulKeyValue) { AddKey(lpKeyName)->SetULong(ulKeyValue); }
    inline void SetHex(const char* lpKeyName, long lKeyValue) { AddKey(lpKeyName)->SetHex(lKeyValue); }
    inline void SetUHex(const char* lpKeyName, unsigned long ulKeyValue) { AddKey(lpKeyName)->SetUHex(ulKeyValue); }
	inline void SetDouble(const char* lpKeyName, double dblKeyValue) { AddKey(lpKeyName)->SetDouble(dblKeyValue); }
	inline void SetString(const char* lpKeyName, const char* lpKeyValue) { AddKey(lpKeyName)->SetString(lpKeyValue); }
	inline void SetMultiLineString(const char* lpKeyName, const char* lpKeyValue) { AddKey(lpKeyName)->SetMultiLineString(lpKeyValue); }
    string GetText();
    string GetTextEx();
    void JoinTo(IniSectionInfo& tarSection);
	inline const char* SplitStrP();
	inline string& SplitStrR();
protected:
    string m_strSectionName;
    IniFileManager* m_pManager;
};



typedef IniSectionInfo* PIniSectionInfo;

class IniFileManager : public WNCLoopList<IniSectionInfo>
{
public:
    IniFileManager(bool bAutoSave = false);
	virtual ~IniFileManager();
    virtual inline PIniSectionInfo AddSection(const char* lpSectionName, bool bAdd = true) { return GetSection(lpSectionName, bAdd); }
    virtual PIniSectionInfo AddSectionEx(const char* lpSectionName);
    virtual PIniSectionInfo GetSection(const char* lpSectionName, bool bAdd = false);
    virtual bool ParseSectionName(const char* lpData, string& strSectionName);
    virtual PIniSectionInfo ParseLine(const char* lpData, bool* pbReplace = NULL);
    virtual bool ParseData(const char* lpData, bool* pbReplace = NULL);
    virtual bool ParseFile(const char* lpFileName, bool* pbReplace = NULL);
    virtual bool SaveFile(const char* lpFileName = NULL, bool* pbUnicode = NULL);
    virtual bool SaveFileEx(const char* lpFileName = NULL, bool* pbUnicode = NULL);
    virtual long ToLong(const char* lpSectionName, const char* lpKeyName, long lDefault = 0);
    virtual unsigned long ToULong(const char* lpSectionName, const char* lpKeyName, unsigned long ulDefault = 0);
    virtual long ToHex(const char* lpSectionName, const char* lpKeyName, long lDefault = 0);
    virtual unsigned long ToUHex(const char* lpSectionName, const char* lpKeyName, unsigned long ulDefault = 0);
    virtual double ToDouble(const char* lpSectionName, const char* lpKeyName, double dblDefault = 0.0);
	virtual string ToString(const char* lpSectionName, const char* lpKeyName, const char* lpDefault = (""));
	virtual string ToMultiLineString(const char* lpSectionName, const char* lpKeyName, const char* lpDefault = (""));
    virtual inline void SetLong(const char* lpSectionName, const char* lpKeyName, long lKeyValue) { AddSection(lpSectionName)->SetLong(lpKeyName, lKeyValue); }
    virtual inline void SetULong(const char* lpSectionName, const char* lpKeyName, unsigned long ulKeyValue) { AddSection(lpSectionName)->SetULong(lpKeyName, ulKeyValue); }
    virtual inline void SetHex(const char* lpSectionName, const char* lpKeyName, long lKeyValue) { AddSection(lpSectionName)->SetHex(lpKeyName, lKeyValue); }
    virtual inline void SetUHex(const char* lpSectionName, const char* lpKeyName, unsigned long ulKeyValue) { AddSection(lpSectionName)->SetUHex(lpKeyName, ulKeyValue); }
	virtual inline void SetDouble(const char* lpSectionName, const char* lpKeyName, double dblKeyValue) { AddSection(lpSectionName)->SetDouble(lpKeyName, dblKeyValue); }
	virtual inline void SetString(const char* lpSectionName, const char* lpKeyName, const char* lpKeyValue) { AddSection(lpSectionName)->SetString(lpKeyName, lpKeyValue); }
	virtual inline void SetMultiLineString(const char* lpSectionName, const char* lpKeyName, const char* lpKeyValue) { AddSection(lpSectionName)->SetMultiLineString(lpKeyName, lpKeyValue); }
    virtual string GetText();
    virtual string GetTextEx();
    virtual void JoinTo(IniFileManager& tarIniManager);
	virtual void SetAutoSave(bool bAutoSave);
	virtual inline bool GetAutoSave() { return m_bAutoSave; }
	//保存GetTextEx的结果
	virtual void SaveState();
	//判断文件内容是否改变
	//带Ex的函数只检查mstrContentSaved与GetTextEx的内容是否相同
	virtual bool DidStateChanged();
	virtual bool DidStateChangedEx();
	inline const char* SplitStrP();
	inline string& SplitStrR();
protected:
    string mstrIniFileName;
	string mstrLineSplit; //行分割符，用于保存文件，解析数据时自动记录
    bool m_bUnicode;
	bool m_bAutoSave;
	string mstrContentSaved;
};


#endif
