/*utf8解析行 Don't remove or modify this first line!*/
//#include "stdafx.h"
#include "WNInvoker.h"


WNInvokeInfo::WNInvokeInfo()
	:mbInvoked(FALSE)
	,muInvokeTime(0)
	,mpReturnValue(NULL)
{

}


WNInvokeInfo::~WNInvokeInfo()
{
	Reset();
}


//======================================================================================================

void WNInvokeInfo::Reset()
{
	mbInvoked = FALSE;
	muInvokeTime = 0;
	mpReturnValue = NULL;
}

void WNInvoker::AddInvokeInfo( WNInvokeInfo* pInvokeInfo )
{
	if (!pInvokeInfo)
	{
		return;
	}
	mInvokeLocker.LockWrite();
	if (!mInvokeList.ListCount())
	{
		pInvokeInfo->Retain();
		mInvokeList.AppendNode(pInvokeInfo);
		mInvokeLocker.ReleaseWrite();
		return;
	}
	else
	{
		WNCLoopList<WNInvokeInfo*>::PNode pNode = NULL;
		for (mInvokeList.MoveEnd(); mInvokeList.NotHead(); mInvokeList.MovePrev())
		{
			pNode = mInvokeList.Current();
			if (pNode->data->muInvokeTime <= pInvokeInfo->muInvokeTime)
			{
				pInvokeInfo->Retain();
				mInvokeList.AppendNode(pInvokeInfo, pNode);
				mInvokeLocker.ReleaseWrite();
				return;
			}
		}
		pInvokeInfo->Retain();
		mInvokeList.PreAppendNode(pInvokeInfo);
		mInvokeLocker.ReleaseWrite();
		return;
	}
}

BOOL WNInvoker::DoCheckAndInvoke()
{
	if (!DoCheckInvoke())
	{
		return FALSE;
	}

	if (!DoInvoke())
	{
		return FALSE;
	}

	while (DoCheckInvoke())
	{
		DoInvoke();
	}
	return TRUE;
}

BOOL WNInvoker::DoCheckInvoke()
{
	mInvokeLocker.LockRead();
	if (!mInvokeList.ListCount())
	{
		mInvokeLocker.ReleaseRead();
		return FALSE;
	}
	UINT uCurrentTime = getCurrentTime();
	if (mInvokeList.BeginData()->muInvokeTime <= uCurrentTime)
	{
		mInvokeLocker.ReleaseRead();
		return TRUE;
	}
	else
	{
		mInvokeLocker.ReleaseRead();
		return FALSE;
	}
}

BOOL WNInvoker::DoInvoke()
{
	mInvokeLocker.LockWrite();
	if (!mInvokeList.ListCount())
	{
		mInvokeLocker.ReleaseWrite();
		return FALSE;
	}
	WNInvokeInfo* pInvokeInfo = mInvokeList.BeginData();
	mInvokeList.RemoveNode(mInvokeList.Begin());
	pInvokeInfo->InvokeMemberFunc();
	pInvokeInfo->Release();
	mInvokeLocker.ReleaseWrite();
	return TRUE;
}
