/*utf8解析行 Don't remove or modify this first line!*/
#ifdef __WINOS__
#include "stdafx.h"
#endif
#include "WNReadWriteLocker.h"
#include "WNCreticalSection.h"
#include <unistd.h>

#include <stdio.h>     
#include <sys/time.h>       
long getCurrentTime()    
{    
   struct timeval tv;    
   gettimeofday(&tv,NULL);    
   return tv.tv_sec * 1000 + tv.tv_usec / 1000;    
}    


WNReadWriteLocker::WNReadWriteLocker()
	:m_dwReadCount(0)
	,m_dwWriteCount(0)
	,m_bWriting(false)
{
	mpLocker = new WNCreticalSection;
}


WNReadWriteLocker::~WNReadWriteLocker()
{
	delete mpLocker;
	mpLocker = 0;
}


bool WNReadWriteLocker::LockRead(unsigned long dwTimeOut /* = 0 */)
{
	if (!dwTimeOut)
	{
		//超时为零，等待直到设置读状态成功
		while (!InternalLockRead())
		{
			usleep(1000);
		}
		return true;
	}
	else
	{
		//超时为非零，等待直到设置读状态成功或者超时
		unsigned long dwStart = getCurrentTime();
		if (!InternalLockRead())
		{
			usleep(1000);
		}
		else
		{
			return true;
		}
		while (!InternalLockRead())
		{
			if (getCurrentTime() - dwStart > dwTimeOut)
			{
				return false;
			}
			usleep(1000);
		}
		return true;
	}
}

bool WNReadWriteLocker::LockWrite(unsigned long dwTimeOut /* = 0 */)
{
	mpLocker->Lock();
	m_dwWriteCount++;
	long dlTimeout = dwTimeOut;
	mpLocker->Unlock();
	if (!dwTimeOut)
	{
		//超时为零，等待直到设置写状态成功
		while (!InternalLockWrite())
		{
			usleep(1000);
		}
		return true;
	}
	else
	{
		//超时为非零，等待直到设置写状态成功或者超时
		long dwStart = getCurrentTime();
		if (!InternalLockWrite())
		{
			usleep(1000);
		}
		else
		{
			return true;
		}
		while (!InternalLockWrite())
		{
			if (getCurrentTime() - dwStart > dlTimeout)
			{
				mpLocker->Lock();
				m_dwWriteCount--;
				mpLocker->Unlock();
				return false;
			}
			usleep(1000);
		}
		return true;
	}
}

bool WNReadWriteLocker::ReleaseRead()
{
	mpLocker->Lock();
	m_dwReadCount--;
	mpLocker->Unlock();
	return true;
}

bool WNReadWriteLocker::ReleaseWrite()
{
	mpLocker->Lock();
	m_dwWriteCount--;
	m_bWriting = false;
	mpLocker->Unlock();
	return true;
}

bool WNReadWriteLocker::InternalLockRead()
{
	mpLocker->Lock();
	if (!m_dwWriteCount)
	{
		m_dwReadCount++;
		mpLocker->Unlock();
		return true;
	}
	else
	{
		mpLocker->Unlock();
		return false;
	}
}

bool WNReadWriteLocker::InternalLockWrite()
{
	mpLocker->Lock();
	if (m_dwReadCount)
	{
		mpLocker->Unlock();
		return false;
	}
	else if (m_bWriting)
	{
		mpLocker->Unlock();
		return false;
	}
	else
	{
		m_bWriting = true;
		mpLocker->Unlock();
		return true;
	}
}
