/*utf8解析行 Don't remove or modify this first line!*/
//#include "StdAfx.h"
#include "WNSocketObserver.h"


WNSocketObserverTarget::WNSocketObserverTarget()
	:mSocket(INVALID_SOCKET)
	,mSocketState(SS_None)
	,mObserverName("")
	,mpLocker(NULL)
    ,mlLockRef(0)
	,mdwLockedThreadId(0)
	,mpObserverTargetDelegate(NULL)
	,miObserverErrorCode(0)
    ,mLockedThreadId(0)
{
	CreateLocker();
}

WNSocketObserverTarget::~WNSocketObserverTarget()
{
	DestroyLocker();
}

void WNSocketObserverTarget::CreateLocker()
{
	if (!mpLocker)
	{
		mpLocker = new WNCreticalSection();
	}
	
}

void WNSocketObserverTarget::DestroyLocker()
{
	if (mpLocker)
	{
		delete mpLocker;
		mpLocker = NULL;
	}
}


bool WNSocketObserverTarget::TryLock()
{
	if (mpLocker)
	{
		if(true == mpLocker->TryLock())
        {
			mLockedThreadId = pthread_self();
            mlLockRef++;
		}else{
			return false;
		}
	}
	else
	{
		//没有初始化锁，默认返回TRUE表示可以操作
		return true;
	}
	return true;
}

bool WNSocketObserverTarget::Lock()
{
    if (mpLocker)
    {
        if (mpLocker->Lock())
        {
            mlLockRef++;
            return true;
        }
        else
        {
            return false;
        }
    }
    return true;
}

bool WNSocketObserverTarget::Unlock()
{
	if(mpLocker)
    {
		if(pthread_self() == mLockedThreadId)
        {
            mlLockRef--;
            if (!mlLockRef)
            {
                mLockedThreadId = 0;
            }
		}
        mpLocker->Unlock();
	}
	
	return true;
}





