/*utf8解析行 Don't remove or modify this first line!*/
#include "WNSocketObserverManager.h"
#include <cstring>
#include <string>
using namespace std;


WNSocketObserverManager& GetObserverManagerRef()
{
    static WNSocketObserverManager gObserverManager;
    return gObserverManager;
}

WNCLoopList<IWNSocketObserver*>& GetObserverListRef()
{
    static WNCLoopList<IWNSocketObserver*> gObserverList;
    return gObserverList;
}

#define mObserverList \
    GetObserverListRef()
#define mObserverManager GetObserverManagerRef()


//对socket进行初始化
WNSocketObserverManager::WNSocketObserverManager()
{


	

}

bool WNSocketObserverManager::RegisterObserver( IWNSocketObserver* observer )
{
    for (mObserverList.MoveBegin(); mObserverList.NotHead(); mObserverList.MoveNext())
    {

        if (!std::strcmp(mObserverList.CurrentData()->GetServerName(), observer->GetServerName()))
        {
            //查找到相同的server，退出函数
            return true;
        }
    }
    //添加至server列表
    mObserverList.AppendNode(observer);
	return true;
}


IWNSocketObserver* WNSocketObserverManager::GetObserverByName( const char* lpName )
{
	WNSocketObserverList::PNode pNode = NULL;
	for (pNode = mObserverList.Begin(); pNode != mObserverList.Head(); pNode = pNode->nextNode)
	{
		if (!::strcmp(pNode->data->GetServerName(), lpName))
		{
			//查找到相同的server，退出函数
			return pNode->data;
		}
	}
	//没有找到指定名称的server
	return NULL;
}


WNSocketObserverList* WNSocketObserverManager::GetObserverList()
{
    return &mObserverList;
}


bool WNSocketObserverManager::AddSocket( WNSocketObserverTarget* socketInfo )
{
	if (socketInfo->mObserverName == "")
	{
		//没有指定observer的名称
		//用列表中的第一个observer
		if (mObserverList.ListCount())
		{
			socketInfo->mObserverName = mObserverList.BeginData()->GetServerName();
		}
		else
		{
			//列表中没有observer
			return false;
		}
	}
	IWNSocketObserver* pObserver = GetObserverByName(socketInfo->mObserverName.c_str());
	if (pObserver)
	{
		pObserver->AddSocket(socketInfo);
	}
	else
	{
		//没有找到指定的observer
		return false;
	}
	return true;
}

bool WNSocketObserverManager::RemoveSocket( WNSocketObserverTarget* socketInfo )
{
	WNSocketObserverList::PNode pNode = NULL;
	for (pNode = mObserverList.Begin(); pNode != mObserverList.Head(); pNode = pNode->nextNode)
	{
		pNode->data->RemoveSocket(socketInfo);
	}
	return true;
}

